Public Member Functions | Static Public Attributes

# MusicWindow Struct Reference

Inheritance diagram for MusicWindow:

## Public Member Functions
| MusicWindow (WindowDesc *desc, WindowNumber number)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
## Static Public Attributes
static const int | slider_width = 3

## Detailed Description

Definition at line 510 of file music_gui.cpp.

## Member Function Documentation

virtual void MusicWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 562 of file music_gui.cpp.

References _current_text_dir, _music_wnd_cursong, _settings_client, _song_is_active, DrawFrameRect(), DrawString(), MusicSettings::effect_vol, FR_LOWERED, GetSongName(), GetTrackNumber(), GfxFillRect(), ClientSettings::music, MusicSettings::music_vol, PC_BLACK, SA_HOR_CENTER, SetDParam(), SetDParamStr(), TD_RTL, WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, WD_FRAMERECT_TOP, WID_M_EFFECT_VOL, WID_M_MUSIC_VOL, WID_M_TRACK_NAME, and WID_M_TRACK_NR.

virtual void MusicWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 617 of file music_gui.cpp.

References _current_text_dir, _left_button_clicked, _settings_client, _song_is_active, MusicSettings::effect_vol, ClientSettings::music, MusicSettings::music_vol, MusicSettings::playing, Window::SetDirty(), Window::SetWidgetDirty(), Window::SetWidgetLoweredState(), MusicSettings::shuffle, TD_RTL, WID_M_ALL, WID_M_CUSTOM1, WID_M_CUSTOM2, WID_M_EFFECT_VOL, WID_M_EZY, WID_M_MUSIC_VOL, WID_M_NEW, WID_M_NEXT, WID_M_OLD, WID_M_PLAY, WID_M_PREV, WID_M_PROGRAMME, WID_M_SHUFFLE, and WID_M_STOP.

virtual void MusicWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true` |
| ) |  |  | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | Information about the changed data.
  | gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 608 of file music_gui.cpp.

References _settings_client, ClientSettings::music, MusicSettings::playlist, Window::SetDirty(), Window::SetWidgetLoweredState(), and WID_M_ALL.

virtual void MusicWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 520 of file music_gui.cpp.

References _current_text_dir, GetSongName(), GetStringBoundingBox(), maxdim(), NUM_SONGS_AVAILABLE, SetDParamStr(), TD_RTL, WD_FRAMERECT_LEFT, WD_FRAMERECT_TOP, WID_M_NEXT, WID_M_PLAY, WID_M_PREV, WID_M_PROGRAMME, WID_M_SHUFFLE, WID_M_TRACK_NAME, and WID_M_TRACK_NR.

The documentation for this struct was generated from the following file:

- src/music_gui.cpp